From 37905ff234b04ca13cc6bf47ca0e111bc3133b75 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 19 Apr 2024 22:13:01 +0300
Subject: [PATCH 65/65] Hexemplio: Copy Nets from amplio2

See RM #482

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/hexemplio.tilespec     |   1 +
 data/hexemplio/terrain.png  | Bin 202204 -> 221963 bytes
 data/hexemplio/terrain.spec |   2 ++
 data/toonhex.tilespec       |   1 +
 4 files changed, 4 insertions(+)

diff --git a/data/hexemplio.tilespec b/data/hexemplio.tilespec
index b93bb565ac..cdf1657ffe 100644
--- a/data/hexemplio.tilespec
+++ b/data/hexemplio.tilespec
@@ -356,6 +356,7 @@ styles =
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
+      "tx.nets",       "Single1"
       "base.outpost",  "3Layer"
       "base.fortress", "3Layer"
       "base.airstrip", "3Layer"
diff --git a/data/hexemplio/terrain.png b/data/hexemplio/terrain.png
index 9317afc1451b2cf18957ab2c955847ad686b2ece..a819b82cddebc60dc1b5c054c3f785f152ec4ae0 100644
GIT binary patch
diff --git a/data/hexemplio/terrain.spec b/data/hexemplio/terrain.spec
index 9146205011..0e2c2b2a1c 100644
--- a/data/hexemplio/terrain.spec
+++ b/data/hexemplio/terrain.spec
@@ -131,6 +131,8 @@ tiles = { "row", "column","tag"
  6, 2, "path.normal"          ; tip of path with MP remaining
  6, 3, "path.waypoint"
 
+ 6, 4, "tx.nets"
+
 ; Irrigation (as special type), and whether north, south, east, west
 
  4,  3, "tx.irrigation_s_n0e0se0s0w0nw0"
diff --git a/data/toonhex.tilespec b/data/toonhex.tilespec
index 428a7cb9d6..d97cc943f4 100644
--- a/data/toonhex.tilespec
+++ b/data/toonhex.tilespec
@@ -379,6 +379,7 @@ styles =
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
+      "tx.nets",       "Single1"
       "base.outpost",  "3Layer"
       "base.fortress", "3Layer"
       "base.airstrip", "3Layer"
-- 
2.43.0