From ed710f348bc5a28604e4dc167544a7d9bbd97faf Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 21 Apr 2024 23:43:19 +0300
Subject: [PATCH 52/52] INSTALL: Remove double spaces

See RM #497

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 INSTALL | 40 ++++++++++++++++++++--------------------
 1 file changed, 20 insertions(+), 20 deletions(-)

diff --git a/INSTALL b/INSTALL
index c975cee345..430f4505c0 100644
--- a/INSTALL
+++ b/INSTALL
@@ -31,9 +31,9 @@ This document contains sections and subsections as follows:
 0. Prerequisites:
 =================
 
-Freeciv has a number of prerequisites.  Note, that apart from the first
+Freeciv has a number of prerequisites. Note, that apart from the first
 prerequisite, the Freeciv configuration process is smart enough to work
-out whether your system is suitable.  If in doubt, just try it.
+out whether your system is suitable. If in doubt, just try it.
 
  - Unix (or similar)
 
@@ -46,12 +46,12 @@ out whether your system is suitable.  If in doubt, just try it.
 
  - An ANSI C compiler.
 
-   Freeciv is written in very portable (almost) ANSI C.  Both 32- and 64-
-   bit machines are supported.  You cannot use a "K&R C" compiler, or
+   Freeciv is written in very portable (almost) ANSI C. Both 32- and 64-
+   bit machines are supported. You cannot use a "K&R C" compiler, or
    a C++ compiler.
 
    Development of Freeciv is primarily done with "gcc", the GNU
-   project's excellent C compiler.  Releases can be compiled with gcc
+   project's excellent C compiler. Releases can be compiled with gcc
    or most other compilers (such as clang or the unbundled Solaris C compiler).
 
  - A "make" program.
@@ -131,12 +131,12 @@ Your system will need to satisfy at least one of these sets of prerequisites.
 
 Note that most Linux systems have separate library packages for "runtime"
 library support and for development support (for compiling programs
-which use those libraries).  To compile Freeciv on such systems you
+which use those libraries). To compile Freeciv on such systems you
 will need to have the appropriate "development" packages installed.
 
 Sound support is built in by default if development files for
-"SDL2" and "SDL2_mixer" libraries are found from the system. Minimum
-version for SDL2 is 2.0.6.
+"SDL2" and "SDL2_mixer" libraries are found from the system.
+Minimum version for SDL2 is 2.0.6.
 
      https://github.com/libsdl-org/SDL_mixer/releases/download/release-2.8.0/SDL2_mixer-2.8.0.tar.gz
 
@@ -292,7 +292,7 @@ following order: pkgconf, Glib, Atk, Pango, Gdk-Pixbuf, Gtk.
    https://github.com/libsdl-org/SDL/releases/download/release-2.28.5/SDL2-2.28.5.tar.gz
 
    To compile the client using the "SDL2" library add "--enable-client=sdl2"
-   to the Freeciv configure script.  See the section below for more
+   to the Freeciv configure script. See the section below for more
    information about the configure script.
 
  - The "SDL2_image" library.
@@ -369,7 +369,7 @@ parameters which can be passed to configure.
 2b. Generating the Makefile for release versions:
 =================================================
 
-Before you compile Freeciv, you must generate a Makefile.  This makefile
+Before you compile Freeciv, you must generate a Makefile. This makefile
 is configured to suit the features available on your machine.
 
 This configuration is done using the GNU "configure" script.
@@ -381,7 +381,7 @@ the Freeciv files:
  % ../src/configure
 
 This script will then attempt to determine the relevant features (and
-misfeatures!!) of your system.  It should print a page or two of
+misfeatures!!) of your system. It should print a page or two of
 diagnostics about your machine, then stop gracefully.
 
 If you'd like help on the various options supported by the configure
@@ -394,7 +394,7 @@ required libraries are found. If you prefer to override this default,
 you can give configure the "--enable-client=sdl2" option.
 
 If you want to change the compiler options, set the CFLAGS environment
-variable in your shell before running "configure".  For example:
+variable in your shell before running "configure". For example:
 
  % CFLAGS="-O -g -pipe" ../src//configure  [for people using Bourne shell or bash]
 
@@ -407,7 +407,7 @@ If you're tracking down a "core dump", we suggest that you use
 a value of "-g" for CFLAGS.
 
 When you install Freeciv (later), the game components will be copied into
-subdirectories of /usr/local by default.  If you would like to use some
+subdirectories of /usr/local by default. If you would like to use some
 other installation prefix besides /usr/local, you should specify it now:
 
  % ../src/configure --prefix=/opt/freeciv
@@ -423,7 +423,7 @@ If for some reason using "configure" gives you trouble, follow these steps:
   - Let us know, so that we can fix it for the next release!!
 
     Send mail to the freeciv-dev mailing list, telling us what you did,
-    and what the result is.  It would be helpful to include the output
+    and what the result is. It would be helpful to include the output
     of the configure script, and the contents of the "config.status",
     "config.cache" and "config.log" files, which are generated by the
     configure script.
@@ -439,7 +439,7 @@ If all has gone well previous to this point, then compiling Freeciv
 should be as easy as typing "make" (or preferably, "gmake").
 
 If you have problems, read the file BUGS, and follow the advice
-carefully.  If the problem is with "gettext", please read the Native
+carefully. If the problem is with "gettext", please read the Native
 Language Support section, below, for possible work-arounds.
 
 After compilation, the important results are:
@@ -450,7 +450,7 @@ After compilation, the important results are:
   - The "fcgui" and "fcser" scripts.
 
 It's perfectly feasible to play Freeciv in this directory, without
-installing it.  If you do this, the "fcgui" and "fcser" scripts may be
+installing it. If you do this, the "fcgui" and "fcser" scripts may be
 useful, although they are not as necessary as they used to be.
 
 See the README file for more information.
@@ -463,7 +463,7 @@ the source directory; you must install Freeciv for that.)
 ================
 
 Installing Freeciv involves installing the components mentioned in the
-Compiling Freeciv section.  These need to be copied to a directory such
+Compiling Freeciv section. These need to be copied to a directory such
 as /usr/local (the default), /usr/games, /usr/games/freeciv,
 /usr/local/freeciv, or some other suitable directory.
 
@@ -472,11 +472,11 @@ You may like to use the --prefix=DIR configure option (see the Generating
 the Makefile section) to ensure the files get placed where you want.
 
 When the Freeciv client and Freeciv server are run they both need to
-find some files from the "data" directory.  By default freeciv looks
+find some files from the "data" directory. By default freeciv looks
 in the following directories, in order, for any data files: the current
 directory; the "data" subdirectory of the current directory; the
 subdirectory ".freeciv" in the user's home directory; and the directory
-where the files are placed by running "make install".  You can override
+where the files are placed by running "make install". You can override
 this search patch by setting the FREECIV_DATA_PATH environment variable, to
 a single directory or a list of directories separated by colons.
 
@@ -489,7 +489,7 @@ For example:
   (for users of sh, bash, ksh, zsh, etc.)
 
 Also, note that you generally must install Freeciv if you wish to use
-its Native Language Support.  See the README file for more information.
+its Native Language Support. See the README file for more information.
 
 
 5. Native Language Support:
-- 
2.43.0