From e48f5f45f51d5b660ca57d833055331542977ff8 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 3 May 2024 22:31:23 +0300
Subject: [PATCH 60/60] Isophex: Copy Nets from trident

See RM #544

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/isophex.tilespec      |   1 +
 data/isophex/terrain1.png  | Bin 33035 -> 59582 bytes
 data/isophex/terrain1.spec |   1 +
 3 files changed, 2 insertions(+)

diff --git a/data/isophex.tilespec b/data/isophex.tilespec
index 8e91eac8b5..2ad66ee9d5 100644
--- a/data/isophex.tilespec
+++ b/data/isophex.tilespec
@@ -303,6 +303,7 @@ styles =
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
+      "tx.nets",       "Single1"
       "base.outpost",  "3Layer"
       "base.fortress", "3Layer"
       "base.airstrip", "3Layer"
diff --git a/data/isophex/terrain1.png b/data/isophex/terrain1.png
index 061f74e02328e5b6d6bb4f308772179c77cd2c0f..9dbe39f961b8965c9c8e71b3207d50d166c84fac 100644
GIT binary patch
diff --git a/data/isophex/terrain1.spec b/data/isophex/terrain1.spec
index 9f9102a64e..979dedddcd 100644
--- a/data/isophex/terrain1.spec
+++ b/data/isophex/terrain1.spec
@@ -124,6 +124,7 @@ tiles = { "row", "column","tag"
   4,    5, "tx.fallout"
   4,    6, "tx.pollution"
   4,    7, "tx.village"
+  4,    8, "tx.nets"
 
 ; misc
 
-- 
2.43.0