From 98e1e05a37f29f0fa53acb700c10145828f68d4b Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Mon, 6 May 2024 02:39:08 +0300
Subject: [PATCH 63/63] Correct "goverment" to "government"

See RM #556

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/gui-qt/menu.cpp    |  4 ++--
 client/gui-sdl2/dialogs.c |  2 +-
 client/gui-sdl2/gui_id.h  |  2 +-
 client/gui-sdl3/dialogs.c |  2 +-
 client/gui-sdl3/gui_id.h  |  2 +-
 server/unittools.c        | 10 +++++-----
 6 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/client/gui-qt/menu.cpp b/client/gui-qt/menu.cpp
index eb23f37ef7..3dc7cb5faa 100644
--- a/client/gui-qt/menu.cpp
+++ b/client/gui-qt/menu.cpp
@@ -610,7 +610,7 @@ void gov_menu::create() {
   revol_gov = game.government_during_revolution;
   for (i = 0; i < gov_count; ++i) {
     gov = government_by_number(i);
-    if (gov != revol_gov) { // Skip revolution goverment
+    if (gov != revol_gov) { // Skip revolution government
       // Defeat keyboard shortcut mnemonics
       action = addAction(QString(government_name_translation(gov))
                          .replace("&", "&&"));
@@ -637,7 +637,7 @@ void gov_menu::update()
   revol_gov = game.government_during_revolution;
   for (i = 0, j = 0; i < gov_count; i++) {
     gov = government_by_number(i);
-    if (gov != revol_gov) { // Skip revolution goverment
+    if (gov != revol_gov) { // Skip revolution government
       sprite = get_government_sprite(tileset, gov);
       if (sprite != nullptr) {
         actions[j + 1]->setIcon(QIcon(*(sprite->pm)));
diff --git a/client/gui-sdl2/dialogs.c b/client/gui-sdl2/dialogs.c
index 6ac1a8c3c8..59278bf401 100644
--- a/client/gui-sdl2/dialogs.c
+++ b/client/gui-sdl2/dialogs.c
@@ -2403,7 +2403,7 @@ static void popdown_connect_dialog(void)
 /* ==================== Public ========================= */
 
 /**************************************************************************
-                           Select Goverment Type
+                           Select Government Type
 **************************************************************************/
 static struct small_dialog *gov_dlg = NULL;
 
diff --git a/client/gui-sdl2/gui_id.h b/client/gui-sdl2/gui_id.h
index cfa9dfa12d..dc98d49878 100644
--- a/client/gui-sdl2/gui_id.h
+++ b/client/gui-sdl2/gui_id.h
@@ -179,7 +179,7 @@ enum GUI_ID {
   ID_CHANGE_TAXRATE_DLG_TAX_BLOCK_CHECKBOX,
   ID_CHANGE_TAXRATE_DLG_LUX_BLOCK_CHECKBOX,
   ID_CHANGE_TAXRATE_DLG_SCI_BLOCK_CHECKBOX,
-  ID_CHANGE_TAXRATE_DLG_GOVERMENT_LABEL,
+  ID_CHANGE_TAXRATE_DLG_GOVERNMENT_LABEL,
   ID_CHANGE_TAXRATE_DLG_OK_BUTTON,
   ID_CHANGE_TAXRATE_DLG_CANCEL_BUTTON,
   ID_SCIENCE_DLG_WINDOW,
diff --git a/client/gui-sdl3/dialogs.c b/client/gui-sdl3/dialogs.c
index 0b25effd45..f00421a774 100644
--- a/client/gui-sdl3/dialogs.c
+++ b/client/gui-sdl3/dialogs.c
@@ -2400,7 +2400,7 @@ static void popdown_connect_dialog(void)
 /* ==================== Public ========================= */
 
 /**************************************************************************
-                           Select Goverment Type
+                           Select Government Type
 **************************************************************************/
 static struct small_dialog *gov_dlg = NULL;
 
diff --git a/client/gui-sdl3/gui_id.h b/client/gui-sdl3/gui_id.h
index b90daa0168..1369432317 100644
--- a/client/gui-sdl3/gui_id.h
+++ b/client/gui-sdl3/gui_id.h
@@ -179,7 +179,7 @@ enum GUI_ID {
   ID_CHANGE_TAXRATE_DLG_TAX_BLOCK_CHECKBOX,
   ID_CHANGE_TAXRATE_DLG_LUX_BLOCK_CHECKBOX,
   ID_CHANGE_TAXRATE_DLG_SCI_BLOCK_CHECKBOX,
-  ID_CHANGE_TAXRATE_DLG_GOVERMENT_LABEL,
+  ID_CHANGE_TAXRATE_DLG_GOVERNMENT_LABEL,
   ID_CHANGE_TAXRATE_DLG_OK_BUTTON,
   ID_CHANGE_TAXRATE_DLG_CANCEL_BUTTON,
   ID_SCIENCE_DLG_WINDOW,
diff --git a/server/unittools.c b/server/unittools.c
index 69d1e71113..830682c0e8 100644
--- a/server/unittools.c
+++ b/server/unittools.c
@@ -3712,13 +3712,13 @@ static void wakeup_neighbor_sentries(struct unit *punit)
 }
 
 /**********************************************************************//**
-  Does: 1) updates the unit's homecity and the city it enters/leaves (the
-           city's happiness varies). This also takes into account when the
-           unit enters/leaves a fortress.
+  Does: 1) updates the unit's homecity and the city it enters/leaves
+           (the city's happiness varies). This also takes into account when
+           the unit enters/leaves a fortress.
         2) updates adjacent cities' unavailable tiles.
 
-  FIXME: Sometimes it is not necessary to send cities because the goverment
-         doesn't care whether a unit is away or not.
+  FIXME: Sometimes it is not necessary to send cities because
+         the government doesn't care whether a unit is away or not.
 **************************************************************************/
 static bool unit_move_consequences(struct unit *punit,
                                    struct tile *src_tile,
-- 
2.43.0